<template>
  <div class="app-container">
    <GetPos
      :dialogVisible.sync="dialogVisible"
      device="pipe"
      @close="dialogVisible=false"
      @getPath="getPath"
      :pipePath="this.coordinateslist"
    />

    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="97px">
      <el-form-item label="项目名称" prop="fProjectName">
        <el-input
          v-model="queryParams.fProjectName"
          placeholder="请输入项目名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="关联对象类型" prop="fRelationObjectType">
        <el-select v-model="queryParams.fRelationObjectType" placeholder="请选择关联对象类型" clearable size="small">
          <el-option
            v-for="dict in fRelationObjectTypeOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="上报状态" prop="fUploadType">
        <el-select v-model="queryParams.fUploadType" placeholder="请选择上报状态" clearable size="small">
          <el-option label="未上报" value="0" />
          <el-option label="已上报" value="1" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-if="user.roleId==5"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-if="user.roleId==5"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-if="user.roleId==5"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		      :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="processList" @selection-change="handleSelectionChange">
      <el-table-column label="项目名称" align="center" prop="fProjectName" />
      <el-table-column label="燃气企业" align="center" prop="enterpriseName" :show-overflow-tooltip="true"></el-table-column>
      <el-table-column label="关联对象类型" align="center" prop="fRelationObjectType" :formatter="fRelationObjectTypeFormat" />
      <el-table-column label="年度" align="center" prop="fYear">
        <template slot-scope="scope">
          <span v-if="scope.row.fYear != null">{{ scope.row.fYear }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="项目开始时间" align="center" prop="fStartTime" width="150">
        <template slot-scope="scope">
          <span v-if="scope.row.fStartTime != null">{{ scope.row.fStartTime }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="项目结束时间" align="center" prop="fEndTime" width="150">
        <template slot-scope="scope">
          <span v-if="scope.row.fEndTime != null">{{ scope.row.fEndTime }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="联系人" align="center" prop="fConcatPerson">
        <template slot-scope="scope">
          <span v-if="scope.row.fConcatPerson != null">{{ scope.row.fConcatPerson }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="联系电话" align="center" prop="fConcatTel">
        <template slot-scope="scope">
          <span v-if="scope.row.fConcatTel != null">{{ scope.row.fConcatTel }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column :label="fUploadTypeLable" align="center" prop="fUploadType" :formatter="uploadStateFormat">
      </el-table-column>
      <el-table-column :label="fUploadTimeLable" align="center" prop="fUploadTime" width="150" :formatter="uploadTimeFormat">
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="180">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDetail(scope.row)"
          >详情</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-if="user.roleId==5&&scope.row.fUploadType==0"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-if="user.roleId==5&&scope.row.fUploadType==0"
          >删除</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleReport(scope.row)"
            v-if="judgeUploadIsShow((scope.row))"
          >上报</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改老旧管网改造计划对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="1000px" append-to-body destroy-on-close :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="170px">
        <el-row class="el-row-table">

          <el-col :span="12">
            <el-form-item label="项目名称" prop="fProjectName">
              <el-input v-model="form.fProjectName" placeholder="请输入项目名称" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="燃气企业" prop="beyondEnterpriseId">
              <el-select style="width: 100%;" :disabled="isDisabledEnterprise" v-model="form.beyondEnterpriseId" placeholder="请选择">
                <el-option
                  v-for="item in enterprises"
                  :key="item.enterpriseId"
                  :label="item.enterpriseName"
                  :value="item.enterpriseId">
                </el-option>
              </el-select>
            </el-form-item>
            <!--<el-form-item label="燃气企业编码" prop="fEntUuid">-->
              <!--<el-input v-model="form.fEntUuid" placeholder="请输入燃气企业编码" />-->
            <!--</el-form-item>-->
          </el-col>

          <el-col :span="12">

            <el-form-item label="项目所在县级行政区" prop="fRegion">
              <el-select
                v-model="form.fRegion"
                placeholder="请选择县级行政区"
                style="width: 100%"
              >
                <el-option
                  v-for="county in countyInfo"
                  :key="county.fId"
                  :label="county.fName.trim()"
                  :value="county.fId"
                />
              </el-select>
              <!--<el-input v-model="form.fRegion" placeholder="请输入项目所在县级行政区ID" />-->
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="关联对象类型" prop="fRelationObjectType">
              <el-select v-model="form.fRelationObjectType" style="width:100%" placeholder="请选择关联对象类型">
                <el-option
                  v-for="dict in fRelationObjectTypeOptions"
                  :key="dict.dictValue"
                  :label="dict.dictLabel"
                  :value="dict.dictValue"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="年度" prop="fYear">
              <el-date-picker
                style="width:100%"
                v-model="form.fYear"
                type="year"
                value-format="yyyy"
                placeholder="选择年度">
              </el-date-picker>
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="项目开始时间" prop="fStartTime">
              <el-date-picker
                style="width: 100%"
                v-model="form.fStartTime"
                type="datetime"
                value-format="yyyy-MM-dd HH:mm:ss"
                placeholder="选择项目开始时间">
              </el-date-picker>
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="项目结束时间" prop="fEndTime">
              <el-date-picker
                style="width: 100%"
                v-model="form.fEndTime"
                type="datetime"
                value-format="yyyy-MM-dd HH:mm:ss"
                placeholder="选择项目结束时间">
              </el-date-picker>
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="项目总投资/万元" prop="fTotalInvestment">
              <el-input-number style="width: 100%;" v-model="form.fTotalInvestment" class="left-aligned-input" :controls="false" :min="0" placeholder="请输入项目总投资/万元" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="实施主体" prop="fSubjectImplementation">
              <el-input v-model="form.fSubjectImplementation" placeholder="请输入实施主体" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="联系人" prop="fConcatPerson">
              <el-input v-model="form.fConcatPerson" placeholder="请输入联系人" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="联系电话" prop="fConcatTel">
              <el-input :maxlength="11" v-model="form.fConcatTel" placeholder="请输入联系电话" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="实际改造完成时间" prop="fActualFinishTime">
              <el-date-picker
                style="width: 100%"
                v-model="form.fActualFinishTime"
                type="date"
                value-format="yyyy-MM-dd"
                placeholder="选择实际改造完成时间">
              </el-date-picker>
            </el-form-item>
          </el-col>

          <el-col :span="24">
            <el-form-item label="建设内容" prop="fConstructionContent">
              <el-input v-model="form.fConstructionContent" type="textarea" placeholder="请输入内容" />
            </el-form-item>
          </el-col>


          <el-col :span="12">
            <el-form-item label="改造进度/百分比" prop="fReconstructionProgress">
              <el-input-number style="width: 100%;" v-model="form.fReconstructionProgress" class="left-aligned-input" :controls="false" :min="0" :max="100" precision="2" placeholder="请输入改造进度/百分比" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="资金拨付进度/百分比" prop="fFundsDisbursementProgress">
              <el-input-number style="width: 100%;" v-model="form.fFundsDisbursementProgress" class="left-aligned-input" :controls="false" :min="0" :max="100" precision="2"  placeholder="请输入资金拨付进度/百分比" />
            </el-form-item>
          </el-col>

          <el-col :span="24">
            <el-col :span="19">
              <el-form-item label="坐标" prop="coordinates">
                <el-input v-model="form.coordinates"   type="textarea" placeholder="请输入坐标" />
              </el-form-item>
            </el-col>
            <el-col :span="3" style="margin-left: 30px">
              <el-button type="primary" plain @click="MapdialogFun">选择坐标</el-button>
            </el-col>
          </el-col>
        </el-row>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 详情 -->
    <DetailInfo ref="detail"/>
  </div>
</template>

<script>
import { listProcess, getProcess, delProcess, addProcess, updateProcess, exportProcess,reportPipeOldPlanProcess,entReportPipeOldPlanProcess } from "@/api/oldpipesystem/process";
import DetailInfo from "./components/DetailInfo";
import{getInfo} from "@/api/login"
import { enterpriseLists } from "@/api/regulation/info";
import { getDefaultCountyList } from "@/api/area/county";
import GetPos from '@/components/GetPos';

"/";
export default {
  name: "Process",
  components: {
    GetPos,
    DetailInfo
  },
  data() {
    return {
      dialogVisible:false,
      //地图管径回显数据
      coordinateslist: null,
      enterpriseName:"",
      user:{},
      isDisabledEnterprise: false,
      enterprises: [],
      countyInfo: [],
      fUploadTypeLable: "",
      fUploadTimeLable: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      fProjectNames: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 老旧管网改造计划表格数据
      processList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 关联对象类型
      fRelationObjectTypeOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        fProjectName: null,
        fRelationObjectType: null,
        fConcatPerson: null,
        fConcatTel: null,
        fFundsDisbursementProgress: null,
        fUploadType: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        fProjectName: [
          { required: true, message: "项目名称不能为空", trigger: "blur" }
        ],
        fRelationObjectType: [
          { required: true, message: "请选择关联对象", trigger: "change" }
        ],
        fConcatTel: [
          {
            pattern: /^1[3|4|5|6|7|8|9][0-9]\d{8}$/,
            message: '手机号格式有误！',
            trigger: 'blur'
          }
        ],
      }
    };
  },
  created() {
    this.getuserInfo();
    this.getDicts("t_relation_object_type").then(response => {
      this.fRelationObjectTypeOptions = response.data;
    });
    this.getEnterpriseLists();
    this.getCountyInfo();
  },
  methods: {
    //获取县级
    getCountyInfo(){
      getDefaultCountyList().then(res =>{
        if(res.code == 200 && res.data){
        this.countyInfo =  res.data;
      }
    })
    },
    beyondCountyFormat(row){
      let info = this.countyInfo.find(item => item.fId == row.fRegion);
      return info?info.fName:"-";
    },
    getuserInfo(){
      getInfo().then(response => {
        console.log(response);
        this.user = response.user.roles[0]
        this.getList();
      });
    },
    //所属单位
    getEnterpriseLists(){
      const param = {};
        enterpriseLists(param).then(response => {
          this.enterprises = response.rows;
      });
    },
    beyondEnterpriseFormat(row){
      let info = this.enterprises.find(item => item.enterpriseId == row.beyondEnterpriseId);
      return info?info.enterpriseName:"-";
    },
    /** 查询老旧管网改造计划列表 */
    getList() {
      this.loading = true;
      // 企业查自己的数据
      if (this.user.roleId == 5) {
        this.queryParams.fEnterpriseId = this.$store.state.user.enterpriseId
        this.queryParams.entUploadState = this.queryParams.fUploadType;
      }
      // 政府如果按照状态查的话，是查的 govUploadState
      if (this.user.roleId == 3) {
        this.queryParams.govUploadState = this.queryParams.fUploadType;
      }
      listProcess(this.queryParams).then(response => {
        this.processList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 关联对象类型
    fRelationObjectTypeFormat(row, column) {
      return this.selectDictLabel(this.fRelationObjectTypeOptions, row.fRelationObjectType);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },

    //判断 上报是否需要显示，上报分为企业上报 和 政府端上报
    judgeUploadIsShow(row) {

      //角色 1 超级管理员  5 企业
      let roleId = this.user.roleId;

      // 企业端 上报状态 0-未上报，1-已上报
      let entUploadState = row.fUploadType;

      // 政府端 上报状态 0-未上报，1-已上报
      let govUploadState = row.govUploadState;

      // 如果政府端都已经上报，那就不能显示了。
      if(govUploadState === '1') {
        return false;
      }

      // 如果企业端上报了，则企业端就不能显示了，政府端和 超级管理员能显示
      if(entUploadState === '1' && govUploadState === '0') {
        if (roleId === 5) {
          return false;
        } else {
          return true;
        }
      }

      // 别的情况，都显示
      return true;

    },
    //上报状态动态展示
    uploadStateFormat(row, column) {
      //角色 1 超级管理员  5 企业
      let roleId = this.user.roleId;
      if (roleId == 5) {
        this.fUploadTypeLable = "上报状态"
        if (row.fUploadType == '0') {
          return "未上报"
        } else{
          return "已上报"
        }
      } else {
        this.fUploadTypeLable = "上报省厅状态"
        if (row.govUploadState == '0') {
          return "未上报"
        } else{
          return "已上报"
        }
      }
    },
    //上报时间动态展示
    uploadTimeFormat(row, column) {
      //角色 1 超级管理员  5 企业
      let roleId = this.user.roleId;
      if (roleId == 5) {
        this.fUploadTimeLable = "上报时间"
        return row.fUploadTime;
      } else {
        this.fUploadTimeLable = "上报省厅时间"
        return row.govUploadTime;
      }

    },
    // 表单重置
    reset() {
      this.form = {
        fOldPlanProcessId: null,
        fUuid: null,
        fEntUuid: null,
        fRegion: null,
        fProjectName: null,
        fRelationObjectType: null,
        fYear: null,
        fStartTime: null,
        fEndTime: null,
        fTotalInvestment: null,
        fCreateTime: null,
        fUpdateTime: null,
        fSubjectImplementation: null,
        fConcatPerson: null,
        fConcatTel: null,
        fConstructionContent: null,
        fActualFinishTime: null,
        fReconstructionProgress: null,
        fFundsDisbursementProgress: null,
        fUploadType: null,
        fUploadTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.fOldPlanProcessId);
      this.fProjectNames = selection.map(item => item.fProjectName);
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.coordinateslist = null;
      this.reset();
      this.open = true;
      this.title = "添加老旧管网改造计划";
      // 说明是 企业在新增，直接赋值显示就行了。
      if (this.enterprises.length == 1) {
        this.form.beyondEnterpriseId = this.enterprises[0].enterpriseId
        this.isDisabledEnterprise = true;
      }
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const fOldPlanProcessId = row.fOldPlanProcessId || this.ids
      getProcess(fOldPlanProcessId).then(response => {
        this.form = response.data;

        const text=this.form.coordinates
        if(text){
          this.coordinateslist=JSON.parse(text);
        }

        this.open = true;
        this.title = "修改老旧管网改造计划";

        // 说明是 企业在新增，直接赋值显示就行了。
        if (this.enterprises.length == 1) {
          this.form.beyondEnterpriseId = this.enterprises[0].enterpriseId
          this.isDisabledEnterprise = true;
        }
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.fOldPlanProcessId != null) {
            updateProcess(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            this.form.fEnterpriseId=this.enterprises[0].enterpriseId;
            addProcess(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const fOldPlanProcessIds = row.fOldPlanProcessId || this.ids;
      const fProjectNames = row.fProjectName || this.fProjectNames;
      this.$confirm('是否确认删除老旧管网改造计划项目名称为"' + fProjectNames + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delProcess(fOldPlanProcessIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有老旧管网改造计划数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;

          // 企业查自己的数据
          if (this.user.roleId == 5) {
            this.queryParams.fEnterpriseId = this.$store.state.user.enterpriseId
          }
          // 政府如果按照状态查的话，是查的 govUploadState
          if (this.user.roleId == 3) {
            this.queryParams.govUploadState = this.queryParams.fUploadType;
          }
          return exportProcess(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    //详情
    handleDetail(row){
      this.$refs.detail.getDetailInfo(row.fOldPlanProcessId);
    },
    handleReport(row){
      // 如果是  超级管理员或者 企业，并且 企业端上报状态为0
      if (this.user.roleId == 5 && row.fUploadType == '0') {
        this.$confirm('是否确认上报老旧管网改造计划项目名称为"' + row.fProjectName + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
          }).then(function() {
            return entReportPipeOldPlanProcess({fOldPlanProcessId : row.fOldPlanProcessId});
          }).then(() => {
            this.getList();
            this.msgSuccess("上报成功");
          }).catch(() => {});
      }


      // 如果是  超级管理员或者 政府，并且 政府端上报状态为0
      if (this.user.roleId == 3  && row.govUploadState == '0') {
        this.$confirm('是否确认上报老旧管网改造计划项目名称为"' + row.fProjectName + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
        }).then(function() {
          return reportPipeOldPlanProcess({fOldPlanProcessId : row.fOldPlanProcessId});
        }).then(() => {
          this.getList();
          this.msgSuccess("上报成功");
        }).catch(() => {});
      }
    },
    /**管道信息 选择管道提交数据方法*/
    getPath(e){
      // for (let i=0;i<e.length;i++){
      //   console.log(e[i])
      //   coordinates.push(e[i])
      // }
      var a = '['
      for (var i in e) {
        if (i == e.length - 1) {
          a += '[' + e[i].toString()+']'
        } else {
          a += '[' + e[i].toString()+'],'
        }
      }
      a += ']'
      this.form.coordinates=a;
    },
    /** 管道打开方法*/
    MapdialogFun(){
      this.dialogVisible=true;
    }
  }
};
</script>
<style>
/* 自定义输入框样式 */
.left-aligned-input .el-input__inner{
  text-align: left;
  padding-left: 5px; /* 根据需要调整内边距 */
}
</style>
